--- DISK-BASED TABLES SELECT tests - NONCLUSTERED INDEX - MULTI-TABLE JOIN

USE SQLLAB;
SET NOCOUNT ON;


declare @Trial int = 5

DECLARE @sql nvarchar(1000)=
'select 
	m.col1, m.col2, m.col3, col4, l1.code1, l2.code2, l3.code3 

from maintable_regular m 

left join lookup1table_regular l1
	on m.col2=l1.col2 and m.code1 = l1.code1 
left join lookup2table_regular l2
	on m.col2=l2.col2 and m.code2 = l2.code2
left join lookup3table_regular l3 
	on m.col2=l3.col2 and m.code3 = l3.code3

where 
	<filter type> 

'
DECLARE @filterType nvarchar(500)=''

set @filterType =
case 
when @Trial = 8 then   
	' m.col2 IN (0,1,2, 3)   --- Trial 8
	and m.code1 = ''code1-1''
	and m.code2 = ''code2-1''
	and m.code3 = ''code3-1'' '

when @Trial = 7 then 
	' m.col2 < 4				--- Trial 7
	and
	m.col2 > 2 '

when @Trial = 6 then 
	' m.col2 = 3				--- Trial 6
	and
	m.code3 = ''code3-3'' '

when @Trial = 5 then 
	' m.code3 = ''code3-3''	--- Trial 5 '
end ;

set @sql = REPLACE(@sql, '<filter type>', @filterType); 

declare @runs int =10, @run int=0;

dbcc dropcleanbuffers;
dbcc freeproccache;

set statistics time on;
while (@run < @runs) BEGIN 

	execute( @sql );


	SET @run = @run + 1;
END
set statistics time off;

